diff --git a/django/contrib/admin/checks.py b/django/contrib/admin/checks.py
index 48539fe..62c3710 100644
--- a/django/contrib/admin/checks.py
+++ b/django/contrib/admin/checks.py
@@ -58,7 +58,7 @@ def check_dependencies(**kwargs):
                 "'django.contrib.auth.context_processors.auth' must be in "
                 "TEMPLATES in order to use the admin application.",
                 id="admin.E402"
-                )
+            )
             errors.append(missing_template)
     return errors
 
diff --git a/django/contrib/flatpages/forms.py b/django/contrib/flatpages/forms.py
index b990fa3..19f3b63 100644
--- a/django/contrib/flatpages/forms.py
+++ b/django/contrib/flatpages/forms.py
@@ -5,12 +5,16 @@ from django.utils.translation import ugettext, ugettext_lazy as _
 
 
 class FlatpageForm(forms.ModelForm):
-    url = forms.RegexField(label=_("URL"), max_length=100, regex=r'^[-\w/\.~]+$',
-        help_text=_("Example: '/about/contact/'. Make sure to have leading"
-                    " and trailing slashes."),
+    url = forms.RegexField(
+        label=_("URL"),
+        max_length=100,
+        regex=r'^[-\w/\.~]+$',
+        help_text=_("Example: '/about/contact/'. Make sure to have leading and trailing slashes."),
         error_messages={
-            "invalid": _("This value must contain only letters, numbers,"
-                         " dots, underscores, dashes, slashes or tildes."),
+            "invalid": _(
+                "This value must contain only letters, numbers, dots, "
+                "underscores, dashes, slashes or tildes."
+            ),
         },
     )
 
diff --git a/django/contrib/flatpages/models.py b/django/contrib/flatpages/models.py
index 67e1a30..b3cad73 100644
--- a/django/contrib/flatpages/models.py
+++ b/django/contrib/flatpages/models.py
@@ -13,7 +13,10 @@ class FlatPage(models.Model):
     title = models.CharField(_('title'), max_length=200)
     content = models.TextField(_('content'), blank=True)
     enable_comments = models.BooleanField(_('enable comments'), default=False)
-    template_name = models.CharField(_('template name'), max_length=70, blank=True,
+    template_name = models.CharField(
+        _('template name'),
+        max_length=70,
+        blank=True,
         help_text=_(
             "Example: 'flatpages/contact_page.html'. If this isn't provided, "
             "the system will use 'flatpages/default.html'."
diff --git a/django/contrib/gis/gdal/prototypes/raster.py b/django/contrib/gis/gdal/prototypes/raster.py
index 4058e19..8b3c350 100644
--- a/django/contrib/gis/gdal/prototypes/raster.py
+++ b/django/contrib/gis/gdal/prototypes/raster.py
@@ -62,7 +62,8 @@ get_band_ds = voidptr_output(std_call('GDALGetBandDataset'), [c_void_p])
 get_band_datatype = int_output(std_call('GDALGetRasterDataType'), [c_void_p])
 get_band_nodata_value = double_output(std_call('GDALGetRasterNoDataValue'), [c_void_p, POINTER(c_int)])
 set_band_nodata_value = void_output(std_call('GDALSetRasterNoDataValue'), [c_void_p, c_double])
-get_band_statistics = void_output(std_call('GDALGetRasterStatistics'),
+get_band_statistics = void_output(
+    std_call('GDALGetRasterStatistics'),
     [
         c_void_p, c_int, c_int, POINTER(c_double), POINTER(c_double),
         POINTER(c_double), POINTER(c_double), c_void_p, c_void_p,
diff --git a/django/views/generic/dates.py b/django/views/generic/dates.py
index d403db8..52b3b39 100644
--- a/django/views/generic/dates.py
+++ b/django/views/generic/dates.py
@@ -658,11 +658,11 @@ class BaseDateDetailView(YearMixin, MonthMixin, DayMixin, DateMixin, BaseDetailV
         if not self.get_allow_future() and date > datetime.date.today():
             raise Http404(_(
                 "Future %(verbose_name_plural)s not available because "
-                "%(class_name)s.allow_future is False.") % {
+                "%(class_name)s.allow_future is False."
+            ) % {
                 'verbose_name_plural': qs.model._meta.verbose_name_plural,
                 'class_name': self.__class__.__name__,
-                },
-            )
+            })
 
         # Filter down a queryset from self.queryset using the date from the
         # URL. This'll get passed as the queryset to DetailView.get_object,
diff --git a/setup.cfg b/setup.cfg
index 8579282..f6ab266 100644
--- a/setup.cfg
+++ b/setup.cfg
@@ -4,7 +4,7 @@ install-script = scripts/rpm-install.sh
 
 [flake8]
 exclude = build,.git,./django/utils/lru_cache.py,./django/utils/six.py,./django/conf/app_template/*,./django/dispatch/weakref_backports.py,./tests/.env,./xmlrunner,tests/view_tests/tests/py3_test_debug.py,tests/template_tests/annotated_tag_function.py
-ignore = E123,E128,E402,W503,W601
+ignore = E128,E402,W503,W601
 max-line-length = 119
 
 [isort]
diff --git a/tests/many_to_one/tests.py b/tests/many_to_one/tests.py
index b3028e0..52ea5d9 100644
--- a/tests/many_to_one/tests.py
+++ b/tests/many_to_one/tests.py
@@ -64,12 +64,10 @@ class ManyToOneTests(TestCase):
 
         self.r.article_set.add(new_article2, bulk=False)
         self.assertEqual(new_article2.reporter.id, self.r.id)
-        self.assertQuerysetEqual(self.r.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: Paul's story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            self.r.article_set.all(),
+            ["<Article: John's second story>", "<Article: Paul's story>", "<Article: This is a test>"]
+        )
 
         # Add the same article to a different article set - check that it moves.
         self.r2.article_set.add(new_article2)
@@ -81,17 +79,14 @@ class ManyToOneTests(TestCase):
             with six.assertRaisesRegex(self, TypeError,
                                        "'Article' instance expected, got <Reporter.*"):
                 self.r.article_set.add(self.r2)
-        self.assertQuerysetEqual(self.r.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            self.r.article_set.all(),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
 
     def test_set(self):
-        new_article = self.r.article_set.create(headline="John's second story",
-                                                pub_date=datetime.date(2005, 7, 29))
-        new_article2 = self.r2.article_set.create(headline="Paul's story",
-                                                  pub_date=datetime.date(2006, 1, 17))
+        new_article = self.r.article_set.create(headline="John's second story", pub_date=datetime.date(2005, 7, 29))
+        new_article2 = self.r2.article_set.create(headline="Paul's story", pub_date=datetime.date(2006, 1, 17))
 
         # Assign the article to the reporter.
         new_article2.reporter = self.r
@@ -108,20 +103,18 @@ class ManyToOneTests(TestCase):
         # Set the article back again.
         self.r2.article_set.set([new_article, new_article2])
         self.assertQuerysetEqual(self.r.article_set.all(), ["<Article: This is a test>"])
-        self.assertQuerysetEqual(self.r2.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: Paul's story>",
-            ])
+        self.assertQuerysetEqual(
+            self.r2.article_set.all(),
+            ["<Article: John's second story>", "<Article: Paul's story>"]
+        )
 
         # Funny case - because the ForeignKey cannot be null,
         # existing members of the set must remain.
         self.r.article_set.set([new_article])
-        self.assertQuerysetEqual(self.r.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            self.r.article_set.all(),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         self.assertQuerysetEqual(self.r2.article_set.all(), ["<Article: Paul's story>"])
 
     def test_reverse_assignment_deprecation(self):
@@ -134,10 +127,8 @@ class ManyToOneTests(TestCase):
             self.r2.article_set = []
 
     def test_assign(self):
-        new_article = self.r.article_set.create(headline="John's second story",
-                                                pub_date=datetime.date(2005, 7, 29))
-        new_article2 = self.r2.article_set.create(headline="Paul's story",
-                                                  pub_date=datetime.date(2006, 1, 17))
+        new_article = self.r.article_set.create(headline="John's second story", pub_date=datetime.date(2005, 7, 29))
+        new_article2 = self.r2.article_set.create(headline="Paul's story", pub_date=datetime.date(2006, 1, 17))
 
         # Assign the article to the reporter directly using the descriptor.
         new_article2.reporter = self.r
@@ -154,30 +145,26 @@ class ManyToOneTests(TestCase):
         # Set the article back again using set() method.
         self.r2.article_set.set([new_article, new_article2])
         self.assertQuerysetEqual(self.r.article_set.all(), ["<Article: This is a test>"])
-        self.assertQuerysetEqual(self.r2.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: Paul's story>",
-            ])
+        self.assertQuerysetEqual(
+            self.r2.article_set.all(),
+            ["<Article: John's second story>", "<Article: Paul's story>"]
+        )
 
         # Because the ForeignKey cannot be null, existing members of the set
         # must remain.
         self.r.article_set.set([new_article])
-        self.assertQuerysetEqual(self.r.article_set.all(),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            self.r.article_set.all(),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         self.assertQuerysetEqual(self.r2.article_set.all(), ["<Article: Paul's story>"])
         # Reporter cannot be null - there should not be a clear or remove method
         self.assertFalse(hasattr(self.r2.article_set, 'remove'))
         self.assertFalse(hasattr(self.r2.article_set, 'clear'))
 
     def test_selects(self):
-        self.r.article_set.create(headline="John's second story",
-                                  pub_date=datetime.date(2005, 7, 29))
-        self.r2.article_set.create(headline="Paul's story",
-                                   pub_date=datetime.date(2006, 1, 17))
+        self.r.article_set.create(headline="John's second story", pub_date=datetime.date(2005, 7, 29))
+        self.r2.article_set.create(headline="Paul's story", pub_date=datetime.date(2006, 1, 17))
         # Reporter objects have access to their related Article objects.
         self.assertQuerysetEqual(self.r.article_set.all(), [
             "<Article: John's second story>",
@@ -199,28 +186,22 @@ class ManyToOneTests(TestCase):
         # Use double underscores to separate relationships.
         # This works as many levels deep as you want. There's no limit.
         # Find all Articles for any Reporter whose first name is "John".
-        self.assertQuerysetEqual(Article.objects.filter(reporter__first_name__exact='John'),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            Article.objects.filter(reporter__first_name__exact='John'),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         # Check that implied __exact also works
-        self.assertQuerysetEqual(Article.objects.filter(reporter__first_name='John'),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+        self.assertQuerysetEqual(
+            Article.objects.filter(reporter__first_name='John'),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         # Query twice over the related field.
         self.assertQuerysetEqual(
-            Article.objects.filter(reporter__first_name__exact='John',
-                                   reporter__last_name__exact='Smith'),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+            Article.objects.filter(reporter__first_name__exact='John', reporter__last_name__exact='Smith'),
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         # The underlying query only makes one join when a related table is referenced twice.
-        queryset = Article.objects.filter(reporter__first_name__exact='John',
-                                       reporter__last_name__exact='Smith')
+        queryset = Article.objects.filter(reporter__first_name__exact='John', reporter__last_name__exact='Smith')
         self.assertNumQueries(1, list, queryset)
         self.assertEqual(queryset.query.get_compiler(queryset.db).as_sql()[0].count('INNER JOIN'), 1)
 
@@ -228,19 +209,15 @@ class ManyToOneTests(TestCase):
         self.assertQuerysetEqual(
             Article.objects.filter(reporter__first_name__exact='John').extra(
                 where=["many_to_one_reporter.last_name='Smith'"]),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         # ... and should work fine with the unicode that comes out of forms.Form.cleaned_data
         self.assertQuerysetEqual(
             (Article.objects
                 .filter(reporter__first_name__exact='John')
                 .extra(where=["many_to_one_reporter.last_name='%s'" % 'Smith'])),
-            [
-                "<Article: John's second story>",
-                "<Article: This is a test>",
-            ])
+            ["<Article: John's second story>", "<Article: This is a test>"]
+        )
         # Find all Articles for a Reporter.
         # Use direct ID check, pk check, and object comparison
         self.assertQuerysetEqual(
@@ -376,21 +353,16 @@ class ManyToOneTests(TestCase):
         r2 = Reporter.objects.create(first_name='John', last_name='Kass', email='jkass@tribune.com')
         Article.objects.create(headline='First', pub_date=datetime.date(1980, 4, 23), reporter=r1)
         Article.objects.create(headline='Second', pub_date=datetime.date(1980, 4, 23), reporter=r2)
-        self.assertEqual(list(Article.objects.select_related().dates('pub_date', 'day')),
-            [
-                datetime.date(1980, 4, 23),
-                datetime.date(2005, 7, 27),
-            ])
+        self.assertEqual(
+            list(Article.objects.select_related().dates('pub_date', 'day')),
+            [datetime.date(1980, 4, 23), datetime.date(2005, 7, 27)]
+        )
         self.assertEqual(list(Article.objects.select_related().dates('pub_date', 'month')),
-            [
-                datetime.date(1980, 4, 1),
-                datetime.date(2005, 7, 1),
-            ])
+            [datetime.date(1980, 4, 1), datetime.date(2005, 7, 1)]
+        )
         self.assertEqual(list(Article.objects.select_related().dates('pub_date', 'year')),
-            [
-                datetime.date(1980, 1, 1),
-                datetime.date(2005, 1, 1),
-            ])
+            [datetime.date(1980, 1, 1), datetime.date(2005, 1, 1)]
+        )
 
     def test_delete(self):
         self.r.article_set.create(headline="John's second story",
@@ -402,27 +374,30 @@ class ManyToOneTests(TestCase):
         Article.objects.create(id=None, headline="Fourth article",
                                pub_date=datetime.date(2005, 7, 27), reporter_id=str(self.r.id))
         # If you delete a reporter, his articles will be deleted.
-        self.assertQuerysetEqual(Article.objects.all(),
+        self.assertQuerysetEqual(
+            Article.objects.all(),
             [
                 "<Article: Fourth article>",
                 "<Article: John's second story>",
                 "<Article: Paul's story>",
                 "<Article: Third article>",
                 "<Article: This is a test>",
-            ])
-        self.assertQuerysetEqual(Reporter.objects.order_by('first_name'),
-            [
-                "<Reporter: John Smith>",
-                "<Reporter: Paul Jones>",
-            ])
+            ]
+        )
+        self.assertQuerysetEqual(
+            Reporter.objects.order_by('first_name'),
+            ["<Reporter: John Smith>", "<Reporter: Paul Jones>"]
+        )
         self.r2.delete()
-        self.assertQuerysetEqual(Article.objects.all(),
+        self.assertQuerysetEqual(
+            Article.objects.all(),
             [
                 "<Article: Fourth article>",
                 "<Article: John's second story>",
                 "<Article: Third article>",
                 "<Article: This is a test>",
-            ])
+            ]
+        )
         self.assertQuerysetEqual(Reporter.objects.order_by('first_name'),
                                  ["<Reporter: John Smith>"])
         # You can delete using a JOIN in the query.
@@ -443,10 +418,8 @@ class ManyToOneTests(TestCase):
         # You can specify filters containing the explicit FK value.
         self.assertQuerysetEqual(
             Article.objects.filter(reporter_id__exact=self.r.id),
-            [
-                "<Article: John's second test>",
-                "<Article: This is a test>",
-            ])
+            ["<Article: John's second test>", "<Article: This is a test>"]
+        )
 
         # Create an Article by Paul for the same date.
         a3 = Article.objects.create(id=None, headline="Paul's commentary",